PROCEDURE jdict

**== ----------------------------------------------------------------- **
*
* Starts the J word Dictionary FoxPro DDE server.
*
* To use this FoxPro server you need a copy of the Windows
* version of J (version 7 or later).
*
* J is unique, elegant, and inexpensive functional programming language
* that is available from:
*                Iverson Software Inc.
*                33 Major Street
*                Toronto, Ontario, Canada
*                M5S 2K9
*
*                Phone (416) 925-6096
*                Fax (416) 488-7559
*
*| jdict Calling sequence:
*|      do jdict  && from command window
** ----------------------------------------------------------------- ==**

WAIT WINDOW "Starting server" NOWAIT

CLOSE DATABASES
SET DELETED ON
SET EXACT OFF
SET NOTIFY OFF

* set public variables
PUBLIC JBfcnt, JBflds, JBjver, JBcode, JBgroups, JBuses, JBgrdir, ;
   JBdictid, JBmissing, JBwork, JBjsdir, JBtests, JBtestdir, ;
   JBdumpjs, JBdumpdir, JBtexdels, JBerror, JBrelbits, ;
   JBnullcode, JBintegrep, JBgrlist, JBitem

JBitem    = 'NONE'
* set error trap
ON ERROR DO jdcrash WITH ;
   ERROR( ), MESSAGE( ), MESSAGE(1), PROGRAM( ), LINENO( )

JBerror   = .F.               && has a trapped error occurred
JBjver    = "7.0"             && default J version
JBgrdir   = 'E:\JCALCS\JS\GR\'   && location of group scripts
JBjsdir   = 'E:\JCALCS\JS\'      && location of JDict table files
JBtestdir = 'E:\JCALCS\JS\JT\'   && location of test case scripts
JBdumpjs  = 'Dumpword'        && Name of J script dump file
JBintegrep = 'Integrep'          && Name integrity report file
JBdumpdir = 'E:\JCALCS\JS\DMP\'  && location of dump files
* potential LaTeX \verb delimiters
JBtexdels = "?~!'@#$%^&()-_+=|}{][\/><;:|.,"

PUBLIC ARRAY JBrelbits(5)     && logical relation mask - initially off

* literals and constants
#DEFINE   JDCode      "Jcode"   && default table names
#DEFINE   JDGroups    "Jgroups"
#DEFINE   JDGrlist    "Jgrlist"
#DEFINE   JDUses      "Juses"
#DEFINE   JDTests     "Jtests"
#DEFINE   JDJBrels    1         && relation mask positions
#DEFINE   JDJGrels    2         && also internal table name order
#DEFINE   JDJGXrels   3
#DEFINE   JDJUXrels   4
#DEFINE   JDJTrels    5
#DEFINE   JDTabcnt    5         && number of related tables
#DEFINE   JDServer    "jdict"   && server name
#DEFINE   JDCodedel   CHR(2)    && reserved delimiter
#DEFINE   JDQuoterep  CHR(3)    && " replacement
#DEFINE   JDSemirep   CHR(4)    && ; replacement
#DEFINE   JDnl        CHR(10)   && newline
#DEFINE   JDcr        CHR(13)   && cr
#DEFINE   JDcrlf      CHR(13)+CHR(10)       && cr/lf
#DEFINE   JDeol       CHR(5)                && dump end of line
#DEFINE   JDLimit     31000     && max number of safe J/DDE chars
#DEFINE   JDNamewid   20        && length of dictionary names
* server messages (not an exhaustive list)
#DEFINE   JDReady     " J server ready"
#DEFINE   JDJend      "A J has gone away"
#DEFINE   JDPurged    " tables have been purged"
#DEFINE   JDRunjdict  '"do jdict" before running this procedure'
#DEFINE   JDSerpfx    "!jdict server: "
#DEFINE   JDNimp      "!jdict server: not implemented yet"
#DEFINE   JDBadtype   "!jdict server: unknown or unsupported field type"
#DEFINE   JDBadfld    "!jdict server: field not found"
#DEFINE   JDTobig     "!jdict server: request to large for DDE"
#DEFINE   JDIntegbad  "!jdict server: integrity violation multiple: "
#DEFINE   JDInuse     "!jdict server: word is in use"
#DEFINE   JDGrpgone   "!jdict server: group missing"
#DEFINE   JDGrphere   "!jdict server: group already exists"
#DEFINE   JDGrpambig  "!jdict server: ambigous group name"
#DEFINE   JDNocalls   "!jdict server: not used"
#DEFINE   JDBadbr     "!jdict server: unknown browse option"
#DEFINE   JDNoswap    "!jdict server: cannot read swap file"
#DEFINE   JDAmbig     "!jdict server: ambigous name"
#DEFINE   JDBadreq    "!jdict server: invalid command"
#DEFINE   JDGiven     "!jdict server: cannot get given name"
* LaTeX/TeX related
#DEFINE   JDSpace     CHR(10)+CHR(10)
#DEFINE   JDVskip     " \medskip "              && LaTeX vertical skip
#DEFINE   JDEmptyset  "\verb? ? $\emptyset$"    && Empty set indented
#DEFINE   JDUpdownar  "$\Updownarrow$"          && Up Down arrow symbol
#DEFINE   JDCodesize  "\footnotesize"   && LaTeX font size for J listings
#DEFINE   JDLatwarn   "% J group Listing LaTeX - WARNING: edit with care!"
* set default external table names
JBcode    = JDCode           && name of JDict code file
JBgroups  = JDGroups         && name of JDict groups file
JBgrlist  = JDGrlist         && name of JDict group Xref file
JBuses    = JDUses           && name of JDict uses Xref file
JBtests   = JDTests          && name of JDict test case file

* constant expression that's used many times
* also used to test that JDICT has been run
JBnullcode = JDEmptyset + JDSpace

* set dictionary config parameters
IF NOT jconfig()
   WAIT WINDOW 'Cannot set configuration parameters - program will stop'
   RETURN
ENDIF

JBmissing = "!jdict server: not in "+JBdictid

* set JDict location
SET DEFAULT TO (JBjsdir)
* use a custom resource file
SET RESOURCE OFF
IF FILE('JDICTUSR.DBF')
   SET RESOURCE TO JDICTUSR.DBF
ENDIF
* test existence of database files
Jok = herejfiles()
IF NOT Jok
   WAIT WINDOW "Dictionary database files are missing - Server will stop!"
   RETURN
ENDIF
* open data base file(s)
IF openjdict()
   * store JB field names in JBflds
   SELECT JB
   JBfcnt = FCOUNT('JB')
   DIMENSION JBflds(JBfcnt)    && JB field name array
   FOR Fcnt = 1 TO JBfcnt
      JBflds(Fcnt) = FIELD(fcnt)
   ENDFOR
   * set DDE services
   = DDESETSERVICE(JDServer, 'DEFINE')
   = DDESETSERVICE(JDServer, 'REQUEST', .T.)
   = DDESETSERVICE(JDServer, 'POKE', .T.)
   = DDESETTOPIC(JDServer, 'DO', 'DOTOPIC')
   WAIT WINDOW UPPER(JDServer) + JDReady NOWAIT
ENDIF
RETURN  &&endproc:jdict


PROCEDURE clrrels
* clear dictionary relations
PARAMETERS dummy
PRIVATE ALL EXCEPT JB*
SELECT JB
SET RELATION OFF INTO JUX
SET RELATION OFF INTO JT
SELECT JG
SET RELATION OFF INTO JGX
IF PARAMETERS() = 1
   FOR i = 1 TO ALEN(JBrelbits)
      JBrelbits(i) = .F.
   ENDFOR
ENDIF
RETURN  &&endproc:clrrels


PROCEDURE dotopic
PARAMETERS channel, action, item, DATA, FORMAT, advise
**== ----------------------------------------------------------------- **
* dotopic is the main DDE event handler.
* dotopic is "called" by DDESETTOPIC()
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
Result = .F.
* save DDE item for crash report
JBitem = item
DO CASE
CASE action = 'INITIATE'
   * It's necessary to return .T. from an
   * INITIATE action or no connection is made
   Result = .T.
CASE action = 'REQUEST'
   * disable this DDE channel while request is being processed
   = DDEENABLED(channel,.F.)
   * execute appropriate request operation
   Jdata = ""
   Jrop  = nthitem(item,1)
   Jname = nthitem(item,2)
   Jname = IIF(EMPTY(Jname), Jname, ALLTRIM(recase(Jname,nthitem(item,3))))
   DO CASE
   CASE Jrop = 'G2'
      SELECT JB
      IF ':'$Jname
         Jdata = JDGiven
      ELSE
         * <item> syntax is "G2,NAME,MASK"
         IF SEEK(Jname)
            IF Jname == ALLTRIM(name)  && insure exact match
               Jdata = jddefmt2(Jname,script,tacit)
            ELSE
               Jdata = JBmissing
            ENDIF
         ELSE
            Jdata = JBmissing
         ENDIF
      ENDIF
   CASE Jrop = 'FLD'   && JB field retrieval
      Jdata = fldget(Jname,item)
   CASE Jrop = 'SEEK'  && seek J names
      Jdata = seekjwords(Jname,item)
   CASE Jrop = 'GRP'   && return list of group members
      Jdata = groups(Jname,item)
   CASE Jrop = 'WHO'   && return list of who uses (calls) Jname
      Jdata = calljword(Jname)
   CASE Jrop = 'DEL'   && delete word
      Jdata = deljword(Jname,item)
   CASE Jrop = 'REN'   && rename word
      Jdata = renjword(Jname,item)
   CASE Jrop = 'ONE'   && return list of words used
      Jdata = uselist(Jname)
   CASE Jrop = 'ALL'   && return "complete" call list
      Jdata = useall(Jname)
   CASE Jrop = 'CON'   && concordance (uses) update
      Jdata = usesjup(Jname,item)
   CASE Jrop = 'DID'   && what dictionary is in use?
      Jdata = ALLTRIM(JBdictid)
   CASE Jrop = 'BRW'   && set browse windows
      Jdata = dictbrow(Jname,item)
   CASE Jrop = 'NP'    && J workspace words not in dictionary
      Jdata = notput(item)
   CASE Jrop = 'CGP'   && create group
      Jdata = crjgrp(Jname)
   CASE Jrop = 'EDL'   && delete group
      Jdata = deljgrp(Jname)
   CASE Jrop = 'EGP'   && empty group
      Jdata = empjgrp(Jname)
   CASE Jrop = 'GMK'   && populate extant groups
      Jdata = grpjmake(Jname,item)
   CASE Jrop = 'WGR'   && groups a word belongs to
      Jdata = injgrps(Jname)
   OTHERWISE
      Jdata = JDBadreq
   ENDCASE
   Result = .T.
   IF LEN(Jdata) > JDLimit
      Jdata = JDTobig
   ENDIF
   * enable DDE channel and return requested data
   = DDEENABLED(channel,.T.)
   = DDEPOKE(channel,item,Jdata) && send data to J
CASE action = 'POKE'
   = DDEENABLED(channel,.F.)
   * execute appropriate poke operation
   Jpkop  = nthitem(item,1)
   Jname = nthitem(item,2)
   Jname = IIF(EMPTY(Jname), Jname, ALLTRIM(recase(Jname,nthitem(item,3))))
   DO CASE
   CASE Jpkop = 'P2'
      Result = put2jcode(Jname,item,DATA)
   OTHERWISE
      Result = .F. && bad pokes
   ENDCASE
   = DDEENABLED(channel,.T.)
CASE action = 'TERMINATE'
   * More than one J process can use the server.
   * Do not shut down the server when a J partner closes.
   WAIT WINDOW JDJend NOWAIT
   Result = .T.
ENDCASE
RETURN Result  &&endproc:dotopic


PROCEDURE dumpwords
**== ----------------------------------------------------------------- **
* Dumps all JB words as a J script on DUMPWORD.JS.
*
*|  Calling sequence:
*|     do dumpwords
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
DO clrrels  && clear relations
Gcnt = 0 && object count
Scrfile = JBdumpdir + JBdumpjs  + '.js'    && J script file
IF FILE(Scrfile)
   ERASE (Scrfile)
ENDIF
Fout = FCREATE(Scrfile)  && create output text files
Temp = 'NB. JB word dump on: '+DTOC(DATE())+' '+TIME()
= FWRITE(Fout,Temp)
WAIT WINDOW 'Dumping words on: '+UPPER(scrfile) NOWAIT
SELECT JB
SCAN FOR nclass = 2 && dump nouns first
   WAIT WINDOW "Dumping: "+ALLTRIM(name) NOWAIT
   Jscr = ALLTRIM(scriptcode2(name,script))
   Jnb  = 'NB. '+ALLTRIM(explain)
   IF 0 < LEN(Jscr)
      = FWRITE(Fout,JDSpace)
      = FWRITE(Fout,Jnb+JDnl+Jscr)
      Gcnt = Gcnt + 1
   ENDIF
ENDSCAN
SCAN FOR nclass != 2 && now dump everything else
   WAIT WINDOW "Dumping: "+ALLTRIM(name) NOWAIT
   Jscr = ALLTRIM(scriptcode2(name,script))
   Jnb  = 'NB. '+ALLTRIM(explain)
   IF 0 < LEN(Jscr)
      = FWRITE(Fout,JDSpace)
      = FWRITE(Fout,Jnb+JDnl+Jscr)
      Gcnt = Gcnt + 1
   ENDIF
ENDSCAN
= FCLOSE(Fout)
DO setrels  && restore relations
WAIT WINDOW ALLTRIM(STR(Gcnt))+' J words dumped' NOWAIT
RETURN  &&endproc:dumpwords


PROCEDURE empjgroup
* remove members of a group
PARAMETERS grname
SET EXACT ON
SELECT JGX
DELETE FOR jgroup = grname
SET EXACT OFF
RETURN &&endproc:empjgroup


PROCEDURE gojdict
**== ----------------------------------------------------------------- **
* This procedure starts the FoxPro J server and a J client process.
* By calling this procedure from the FOXPROW.EXE command line
* it's easy to start the dictionary from the Window's Program
* Manager by clicking on a single Icon.
*
* To use this procedure cut it out of JDICT.PRG and make
* it a stand alone *.prg.  Then edit the path in the *.prg code
* to suit your setup.  Finally make a copy of the Program Manager's
* FoxPro icon and edit it's program properties so the startup
* command line is like the following.
*
*      d:\foxprow\foxprow.exe e:\foxwrk\prg\gojdict.prg
*
* When properly installed this is a much easiar way to start
* the dictionary than described in the article.  I choose the
* article method because it's easiar for Window's and
* FoxPro novices.
** ----------------------------------------------------------------- ==**
* set dictionary directory and start server
SET DEFAULT TO E:\jcalcs\jd
SET PROC TO jdict.prg
DO jdict
* spawn J process and silently load client words
RUN /N D:\j7win\jwin.exe D:\j7win\profile.js /N
RETURN &&endproc:gojdict


PROCEDURE grpbrow
* browse groups
PRIVATE ALL EXCEPT JB*
DO clrrels WITH "bits"
SELECT JG
SET RELATION TO jgroup INTO JGX
BROWSE NOWAIT PREFERENCE JG
JBrelbits(JDJGXrels) = .T.
SELECT JGX
BROWSE NOWAIT PREFERENCE JGX
ACTIVATE WINDOW JG
SELECT JG
RETURN  &&endproc:grpbrow


PROCEDURE hidewins
* hide dictionary windows
IF WEXIST('JB')
   HIDE WINDOW JB
ENDIF
IF WEXIST('JG')
   HIDE WINDOW JG
ENDIF
IF WEXIST('JGX')
   HIDE WINDOW JGX
ENDIF
IF WEXIST('JUX')
   HIDE WINDOW JUX
ENDIF
IF WEXIST('JT')
   HIDE WINDOW JT
ENDIF
RETURN  &&endproc:hidewins


PROCEDURE integrity
* test the referential integrity of the dictionary database
PRIVATE ALL EXCEPT JB*
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
CLOSE DATABASES
* (integrity) is designed to stop when a violation is found.
Rep = JBdumpdir + ALLTRIM(JBintegrep) + '.txt'
IF FILE(Rep)
   ERASE (Rep)
ENDIF
Fout = FCREATE(Rep)
= FWRITE(Fout, ALLTRIM(JBdictid) + " integrity report generated on: ";
   + DTOC(DATE()) + " " + TIME() )
* check files
WAIT WINDOW 'Testing the existence of database files' NOWAIT
IF NOT herejfiles('noinds')
   DO irep WITH Fout, "Database files are missing"
   RETURN
ENDIF
* count primary keys
DIMENSION Pkeys(1,1)
WAIT WINDOW 'Counting primary keys' NOWAIT
SELECT talias, ttable, indexpr FROM jdictkey INTO ARRAY Pkeys ;
   WHERE keyclass = 1 ORDER BY tord
IF JDTabcnt != ALEN(Pkeys,1)
   DO irep WITH Fout, "The number of primary keys != the number of tables"
   RETURN
ENDIF
* rebuild index files
WAIT WINDOW 'Reseting index files' NOWAIT
DO jreset WITH ""
* open data base files
IF NOT openjdict()
   DO irep WITH Fout, "Cannot open " + JBdictid + " database"
   RETURN
ENDIF
* determine if primary keys are unique
WAIT WINDOW 'Testing primary keys' NOWAIT
FOR i = 1 TO JDTabcnt
   IF NOT pkeytest( ALLTRIM(Pkeys(i,1)) , ALLTRIM(Pkeys(i,3)))
      DO irep WITH Fout, ALLTRIM(Pkeys(i,2)) + ;
         " table has duplicate primary keys"
      RETURN
   ENDIF
ENDFOR
* test foreign keys
Fkmsg = "Foreign key violation(s)"
* Uses - concordance table
Fkfile = JBjsdir + JBuses
IF NOT forinteg(Fout, Fkfile, 'JUX', 'name', 'JB', 'name')
   DO irep WITH Fout, Fkmsg
   RETURN
ENDIF
IF NOT forinteg(Fout, Fkfile, 'JUX', 'uses', 'JB', 'name')
   DO irep WITH Fout, Fkmsg
   RETURN
ENDIF
* Grlist - group name cross reference
Fkfile = JBjsdir + JBgrlist
IF NOT forinteg(Fout, Fkfile, 'JGX', 'name', 'JB', 'name')
   DO irep WITH Fout, Fkmsg
   RETURN
ENDIF
Fkfile = JBjsdir + JBgroups
IF NOT forinteg(Fout, Fkfile, 'JGX', 'jgroup', 'JG', 'jgroup')
   DO irep WITH Fout, Fkmsg
   RETURN
ENDIF
* Tests - test cases
Fkfile = JBjsdir + JBtests
IF NOT forinteg(Fout, Fkfile, 'JT', 'name', 'JB', 'name')
   DO irep WITH Fout, Fkmsg
   RETURN
ENDIF
DO irep WITH Fout, JBdictid + " all integrity tests passed"
RETURN &&endproc:integrity


PROCEDURE irep
* write a fatal error message to the integrity report
PARAMETERS fhand, fmsg
PRIVATE ALL EXCEPT JB*
Endm = " - program will stop"
= FWRITE(fhand, JDSpace + fmsg)
= FCLOSE(fhand)
CLOSE DATABASES
WAIT WINDOW fmsg + Endm && wait until uses touches
RETURN &&endproc:irep


PROCEDURE jbbrow
* browse words
DO clrrels WITH "bits"
SELECT JB
BROWSE NOWAIT PREFERENCE JB
ACTIVATE WINDOW JB
RETURN  &&endproc:jbbrow


PROCEDURE jdcrash
* handle the "unlikely" event of server program failure
PARAMETER merror, MESS, mess1, mprog, mlineno
PRIVATE ALL EXCEPT JB*
ON ERROR        && clear trap to avoid infinite trap loops
CLOSE ALL       && lock down data if possible
* I'm dead so I can't talk - releasing the server
* will appear as a sudden loss of server data to J
= DDESETSERVICE(JDServer, 'RELEASE')
JBerror = .T.   && trapped error has occurred
Crashfile = JBdumpdir + 'JDCRASH.TXT'
* attempt to write a bomb message in the dump directory
Bomb = 'Jdict Fatal Server Program Error '
Bomb = Bomb + JDnl + 'Error number: ' + LTRIM(STR(merror))
Bomb = Bomb + JDnl + 'Error message: ' + MESS
Bomb = Bomb + JDnl + 'Line of code with error: ' + mess1
Bomb = Bomb + JDnl + 'Line number of error: ' + LTRIM(STR(mlineno))
Bomb = Bomb + JDnl + 'Program with error: ' + mprog
Bomb = Bomb + JDnl + 'Server DDE Item : ' + JBitem
IF FILE (Crashfile)
   ERASE (Crashfile)
ENDIF
= writetxt(Bomb,Crashfile)
SUSPEND && wait until the posse arrives!
RETURN &&endproc:jdcrash


PROCEDURE jinit
* initialize dictionary tables in current directory
PARAMETERS dictname
PRIVATE ALL EXCEPT JB*
* a quick test to prevent double installs
IF FILE('JDICTCFG.DBF')
   WAIT WINDOW 'A dictionary already exists in this directory'
   RETURN
ENDIF
WAIT WINDOW "Initializing dictionary tables" NOWAIT
IF 0 = PARAMETERS()
   Dname = "Dictionary"    && default dictionary name
ELSE
   Dname = dictname
   IF TYPE('Dname') != 'C'
      WAIT WINDOW "Invalid dictionary name - try another - jinit has failed"
      RETURN
   ENDIF
ENDIF
Crrdir = SYS(5) + CURDIR() && current drive/directory
* all install files
DIMENSION Instfiles(11)
Instfiles(1) = 'jdict.prg'
Instfiles(2) = 'jdict.js'
Instfiles(3) = 'jdictpro.js'
Instfiles(4) = 'jdictkey.dbf'
Instfiles(5) = 'jdictkbk.dbf'
Instfiles(6) = 'jdictusr.dbf'
Instfiles(7) = 'jdictusr.fpt'
Instfiles(8) = 'jdictubk.dbf'
Instfiles(9) = 'jdictubk.fpt'
Instfiles(10) = 'jdictjam.js'
Instfiles(11) = 'jdict.fxp'    && compiled jdict.prg (created by FoxPro)
* insure current directory contains only install files
Curcnt = ADIR(Dcfiles)
IF Curcnt != ALEN(Instfiles)
   WAIT WINDOW "Install directory file count invalid - jinit has failed"
   RETURN
ENDIF
* test existence of install files
FOR i = 1 TO ALEN(Instfiles)
   IF NOT FILE(Instfiles(i))
      WAIT WINDOW "Install file " + UPPER(Instfiles(i)) ;
         + " missing - jinit has failed"
      RETURN
   ENDIF
ENDFOR
* create tables
CLOSE DATABASES
* Config table
CREATE TABLE JDICTCFG ;
   ( jd_code C(8), ;
   jd_groups C(8), ;
   jd_grlist C(8), ;
   jd_uses C(8), ;
   jd_tests C(8), ;
   jd_dir C(128), ;
   jd_grdir C(128), ;
   jd_jtdir C(128), ;
   jd_dictid C(25), ;
   jd_jver C(10), ;
   jd_dumpjs C(8), ;
   jd_dumpdmp C(8), ;
   jd_dumpdir C(128) )
CLOSE DATABASES
* Main J code table
CREATE TABLE JCODE ;
   ( name C(20), ;
   explain C(45), ;
   script M, ;
   document M, ;
   nclass N(1,0), ;
   tacit N(1,0), ;
   creation D, ;
   changed D, ;
   jversion C(6), ;
   creatsec N(5,0), ;
   changesec N(5,0), ;
   changecnt N(4,0), ;
   lastscript M )
CLOSE DATABASES
* Groups table
CREATE TABLE JGROUPS ;
   ( jgroup C(8), ;
   explain C(35), ;
   document M, ;
   generate L, ;
   readable L, ;
   teston L, ;
   locale L )
CLOSE DATABASES
* Group name cross-reference
CREATE TABLE JGRLIST ;
   ( jgroup C(8), ;
   name C(20), ;
   interface L )
CLOSE DATABASES
* Concordance
CREATE TABLE JUSES ;
   ( name C(20), ;
   uses C(20) )
CLOSE DATABASES
* Test cases
CREATE TABLE JTESTS ;
   ( testcase C(45), ;
   name C(20), ;
   expecting C(40), ;
   assumes C(40), ;
   caseon L, ;
   createcase D, ;
   changecase D, ;
   comments M, ;
   casecode M )
CLOSE DATABASES
* set config table before indexing
USE JDICTCFG IN 0 ALIAS JC
SELECT JC
APPEND BLANK
REPLACE jd_code WITH 'Jcode', jd_groups WITH 'Jgroups' ;
   jd_grlist WITH 'Jgrlist', jd_uses WITH 'Juses' ;
   jd_tests WITH 'Jtests', jd_dir WITH Crrdir ;
   jd_grdir WITH Crrdir, jd_jtdir WITH Crrdir ;
   jd_dictid WITH Dname, jd_jver WITH '7.0' ;
   jd_dumpjs WITH 'Dumpword', jd_dumpdir WITH Crrdir
APPEND BLANK
REPLACE jd_code WITH 'Jcode', jd_groups WITH 'Jgroups' ;
   jd_grlist WITH 'Jgrlist', jd_uses WITH 'Juses' ;
   jd_tests WITH 'Jtests', jd_dir WITH 'C:\JDICT\' ;
   jd_grdir WITH 'C:\JDICT\GR\', jd_jtdir WITH 'D:\JTESTS\' ;
   jd_dictid WITH 'Tools Dictionary', jd_jver WITH '7.0' ;
   jd_dumpjs WITH 'Dumpword', jd_dumpdir WITH 'C:\JDICT\DMP\'
CLOSE DATABASES
* set index files
DO jreset WITH ""
* set path in J dictionary profile script
Jprof = readtxt('jdictpro.js')
Jprof = STRTRAN(Jprof,'($-$-*-$-$)', "'" + Crrdir + "'")
ERASE ('jdictpro.js')
IF 0 > writetxt(Jprof,'jdictpro.js')
   WAIT WINDOW "Unable to set J dictionary profile - jinit has failed"
   RETURN
ENDIF
WAIT WINDOW ALLTRIM(Dname) ;
   + ' tables initialized - type "do jdict" to start server' NOWAIT
RETURN &&endproc:jinit


PROCEDURE jpurge
* pack database files
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
WAIT WINDOW "Purging " + JBdictid NOWAIT
SELECT JB
PACK
SELECT JG
PACK
SELECT JGX
PACK
SELECT JUX
PACK
SELECT JT
PACK
WAIT WINDOW JBdictid + JDPurged NOWAIT
RETURN &&endproc:jpurge


PROCEDURE jreset
* rebuilds all index files
PARAMETERS dummy
PRIVATE ALL EXCEPT JB*
* Clear main error trap.  FoxPro considers
* an attempt to open a table without an index
* an error yet one purpose of this procedure
* is to fix that very error.
ON ERROR
IF 0 = PARAMETERS()
   WAIT WINDOW 'Reseting index files' NOWAIT
ENDIF
CLOSE DATABASES
SET NOTIFY OFF
SET SAFETY OFF
Cpaths = ' - cannot reset - check paths'
DIMENSION Dbfnames(5)
DIMENSION Tabnames(5)
DO CASE
CASE NOT FILE('jdictkey.dbf')
   WAIT WINDOW "Key definition file missing" + Cpaths
   RETURN
ENDCASE
IF FILE('jdictcfg.dbf')
   USE jdictcfg
   GO TOP
   Dbfnames(1) = ALLTRIM(jd_code)
   Dbfnames(2) = ALLTRIM(jd_groups)
   Dbfnames(3) = ALLTRIM(jd_grlist)
   Dbfnames(4) = ALLTRIM(jd_uses)
   Dbfnames(5) = ALLTRIM(jd_tests)
   USE
ELSE
   * default names
   Dbfnames(1) = JDCode
   Dbfnames(2) = JDGroups
   Dbfnames(3) = JDGrlist
   Dbfnames(4) = JDUses
   Dbfnames(5) = JDTests
ENDIF
* internal names
Tabnames(1) = 'CODE'
Tabnames(2) = 'GROUPS'
Tabnames(3) = 'GRLIST'
Tabnames(4) = 'USES'
Tabnames(5) = 'TESTS'
* set code
FOR i = 1 TO JDTabcnt
   Curtab = ALLTRIM(Tabnames(i))
   SELECT a.tag, a.indexpr FROM jdictkey A INTO ARRAY Tagarr ;
      WHERE ALLTRIM(a.ttable) == Curtab
   USE
   Tagcnt = ALEN(Tagarr,1)
   IF FILE(Dbfnames(i)+'.cdx')
      ERASE (Dbfnames(i)+'.cdx')
   ENDIF
   USE (Dbfnames(i))
   DELETE TAG ALL
   FOR j = 1 TO Tagcnt
      tagname = ALLTRIM(Tagarr(j,1))
      IF NOT EMPTY(tagname)
         keyexpr = ALLTRIM(Tagarr(j,2))
         INDEX ON &keyexpr TAG &tagname
      ENDIF
   ENDFOR
   USE
   RELEASE Tagarr
ENDFOR
SET SAFETY ON
* reset main error trap
ON ERROR DO jdcrash WITH ;
   ERROR( ), MESSAGE( ), MESSAGE(1), PROGRAM( ), LINENO( )
IF 0 = PARAMETERS()
   WAIT WINDOW UPPER(JDServer) + ;
      ' index files reset - restart server with "do jdict"'
ENDIF
RETURN &&endproc:jreset


PROCEDURE makegroups
**== ----------------------------------------------------------------- **
* makegroups generates group J scripts
*
*|  Calling sequence:
*|     do makegroups
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
Gcnt = 0
* gather a unique list of group names
SELECT DISTINCT Jgx.jgroup;
   FROM  JGX ;
   ORDER BY Jgx.jgroup;
   INTO CURSOR QGRLIST
* for each unique group name generate a J script
SELECT QGRLIST
SCAN
   Jgrname = QGRLIST.jgroup
   * look in group table to resolve generate status
   SELECT Jg
   IF SEEK(Jgrname)   && generate only "official" groups
      IF Jg.generate       && build marked groups
         Lint = Jg.locale  && set locale interface if requested
         WAIT WINDOW 'Generating '+ALLTRIM(Jgrname)+' group' NOWAIT
         * select group members
         SELECT DISTINCT Jb.tacit, Jb.script, Jb.name, ;
            Jb.nclass, Jgx.interface ;
            FROM JB, JGX;
            WHERE Jgx.jgroup = Jgrname;
            AND Jgx.name = Jb.name AND !DELETED();
            ORDER BY Jb.nclass, Jb.name;
            INTO CURSOR QGROUP
         Grscript = JBgrdir+ALLTRIM(QGRLIST.jgroup)+".js"
         IF FILE(Grscript)
            ERASE (Grscript)
         ENDIF
         Fout=FCREATE(Grscript)  && create script file
         = FWRITE(Fout,'NB. '+ALLTRIM(QGRLIST.jgroup)+' group generated on: ' ;
            + DTOC(DATE())+' '+TIME() )
         = FWRITE(Fout,JDnl+'NB. J words extracted from: '+ALLTRIM(JBdictid))
         Lface = ""
         SELECT QGROUP
         SCAN
            Jscr = ALLTRIM(scriptcode2(QGROUP.name,QGROUP.script))
            IF 0 < LEN(Jscr)
               = FWRITE(Fout,JDSpace)
               = FWRITE(Fout,Jscr)
            ENDIF
            IF Lint && collect interface words
               IF QGROUP.interface
                  Lface = Lface + ' ' + ALLTRIM(QGROUP.name)
               ENDIF
            ENDIF
         ENDSCAN
         IF Lint
            = FWRITE(Fout,JDSpace)
            = FWRITE(Fout,"Interface =: '" + Lface + "'")
         ENDIF
         = FCLOSE(Fout)
         Gcnt = Gcnt + 1 && count group
         SELECT QGROUP   && release group member cursor
         USE
      ENDIF
   ENDIF
ENDSCAN
WAIT WINDOW ALLTRIM(STR(Gcnt))+' group script file(s) generated' NOWAIT
SELECT QGRLIST  && release group list cursor
USE
RETURN &&endproc:makegroups


PROCEDURE makelatex
**== ----------------------------------------------------------------- **
* This procedure builds *.jex (J LaTeX) files that contain LaTeX/TeX
* typesetting commands that yield, when passed through LaTeX, spiffy
* J listings.
*
*|  Calling sequence:
*|     do makelatex
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
Gcnt = 0
* gather a unique list of group names
SELECT DISTINCT Jgx.jgroup;
   FROM  JGX ;
   ORDER BY Jgx.jgroup;
   INTO CURSOR QGRLIST
* for each unique group name generate a LaTeX *.jex file
SELECT QGRLIST
SCAN
   Jgrname = QGRLIST.jgroup
   * look in group table to resolve readable status
   SELECT Jg
   IF SEEK(Jgrname)   && generate only "official" groups
      IF Jg.Readable  && build marked groups
         WAIT WINDOW 'Generating '+ALLTRIM(Jgrname)+' LaTeX' NOWAIT
         * select group members
         SELECT DISTINCT Jb.tacit, Jb.script, Jb.name, ;
            Jb.explain, Jb.nclass;
            FROM JB, JGX;
            WHERE Jgx.jgroup = Jgrname;
            AND Jgx.name = Jb.name AND !DELETED();
            ORDER BY Jb.nclass, Jb.name;
            INTO CURSOR QGROUP
         Grscript = JBgrdir+ALLTRIM(QGRLIST.jgroup)+".jex"
         IF FILE(Grscript)
            ERASE (Grscript)
         ENDIF
         Fout=FCREATE(Grscript)  && create latex file
         = FWRITE(Fout,JDLatwarn + JDSpace)
         = FWRITE(Fout,JDCodesize + JDSpace)
         = FWRITE(Fout,'\noindent {\large {\bf '+ALLTRIM(QGRLIST.jgroup)+ ;
            '} group listed on: ' + DTOC(DATE())+' '+TIME() + '}'+JDSpace)
         = FWRITE(Fout,'\noindent {\large J words extracted from: '+ ;
            ALLTRIM(JBdictid) + '}'+JDSpace + JDVskip)
         SELECT QGROUP
         SCAN
            Jscr = ALLTRIM(latexcode(QGROUP.name, QGROUP.tacit, QGROUP.script, ;
               QGROUP.explain, QGROUP.nclass))
            IF 0 < LEN(Jscr)
               = FWRITE(Fout,JDSpace)
               = FWRITE(Fout,Jscr)
            ENDIF
         ENDSCAN
         = FWRITE(Fout,JDnl+'\normalsize'+JDnl)
         = FCLOSE(Fout)
         Gcnt = Gcnt + 1 && count group
         SELECT QGROUP   && release group member cursor
         USE
      ENDIF
   ENDIF
ENDSCAN
WAIT WINDOW ALLTRIM(STR(Gcnt))+' group LaTeX *.jex file(s) generated' NOWAIT
SELECT QGRLIST  && release group list cursor
USE
RETURN &&endproc:makelatex


PROCEDURE nop
* no operation
RETURN &&endproc:nop


PROCEDURE openjerror
PARAMETERS MESS
PRIVATE ALL EXCEPT JB*
JBerror = .T.    && an error as occurred
CLOSE DATABASES  && close all databases
WAIT WINDOW ;
   UPPER(JDServer) + ' open error <<' + MESS + '>> try "do jreset"'
RETURN &&endproc:openjerror


PROCEDURE setrels
* restores active dictionary relation
DO CASE
CASE JBrelbits(JDJUXrels)
   SELECT JB
   SET RELATION TO name INTO JUX
   SET SKIP TO JUX
CASE JBrelbits(JDJTrels)
   SELECT JB
   SET RELATION TO name INTO JT
   SET SKIP TO JT
CASE JBrelbits(JDJGXrels)
   SELECT JG
   SET RELATION TO jgroup INTO JGX
ENDCASE
RETURN  &&endproc:setrels


PROCEDURE testbrow
* browse test cases
PRIVATE ALL EXCEPT JB*
DO clrrels WITH "bits"
SELECT JB
SET RELATION TO name INTO JT
BROWSE NOWAIT PREFERENCE JBJT
JBrelbits(JDJTrels) = .T.
SELECT JT
BROWSE NOWAIT PREFERENCE JTJB
ACTIVATE WINDOW JB
SELECT JG
RETURN  &&endproc:testbrow


PROCEDURE testgroups
**== ----------------------------------------------------------------- **
* testgroups generates group test scripts from "on" test cases.
*
*|  Calling sequences:
*|   do testgroups
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
Gcnt = 0
* gather a unique list of groups that have members
SELECT DISTINCT JGX.jgroup;
   FROM  JGX ;
   ORDER BY JGX.jgroup;
   INTO CURSOR QGRLIST
* for each unique group name generate a J test script
SELECT QGRLIST
SCAN
   Jgrname = QGRLIST.jgroup
   * look in group table to resolve test status
   SELECT JG
   IF SEEK(Jgrname)   && generate only "official" groups
      IF JG.Teston    && test marked groups
         WAIT WINDOW 'Generating '+ALLTRIM(Jgrname)+' test cases' NOWAIT
         * select on test cases for group words
         SELECT JT.name, JT.casecode, JT.testcase, ;
            JT.expecting FROM JT ;
            WHERE JT.name IN (SELECT Jgx.name ;
            FROM JGX WHERE JGX.jgroup = Jgrname AND !DELETED());
            AND JT.caseon ORDER BY JT.name INTO CURSOR QTESTS
         Tscript = JBtestdir+ALLTRIM(QGRLIST.jgroup)+".js"
         IF FILE(Tscript)
            ERASE (Tscript)
         ENDIF
         * create file and set header
         Fout=FCREATE(Tscript)
         = FWRITE(Fout,'NB. '+ALLTRIM(QGRLIST.jgroup)+' test case(s) generated on: ' ;
            + DTOC(DATE())+' '+TIME() )
         = FWRITE(Fout,JDnl+'NB. J test case(s) extracted from: '+ALLTRIM(JBdictid))
         = FWRITE(Fout,JDSpace)
         = FCLOSE(Fout)
         SELECT QTESTS
         SCAN
            * must open/close for COPY MEMO (Kludge!)
            Fout = FOPEN(Tscript,2)
            = FSEEK(Fout, 0, 2) && Move pointer to EOF
            = FWRITE(Fout,JDSpace)
            = FWRITE(Fout,'NB. BEGIN TEST: ' ;
               + ALLTRIM(QTESTS.testcase) + JDSpace)
            = FWRITE(Fout,'NB. EXPECTING: ' ;
               + ALLTRIM(QTESTS.expecting) + JDSpace)
            = FCLOSE(Fout)
            COPY MEMO QTESTS.casecode TO (Tscript) ADDITIVE
         ENDSCAN
         Gcnt = Gcnt + 1 && count group
         SELECT QTESTS   && release group member cursor
         USE
      ENDIF
   ENDIF
ENDSCAN
WAIT WINDOW ALLTRIM(STR(Gcnt))+' test case script file(s) generated' NOWAIT
SELECT QGRLIST  && release group list cursor
USE
RETURN &&endproc:testgroups


PROCEDURE testwords
**== ----------------------------------------------------------------- **
* testwords generates test scripts from "on" word test cases
*
*|  Calling sequences:
*|   do testwords
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
IF "U" = TYPE('JBnullcode')
   WAIT WINDOW JDRunjdict
   RETURN
ENDIF
Gcnt = 0
* gather words with testcases
SELECT DISTINCT JT.name FROM JT WHERE ;
   NOT EMPTY(JT.casecode) AND !DELETED() ;
   INTO CURSOR QTLIST
* for each unique word generate a J test script
* file names are derived from the word name and given
* the extension *.jt to avoid clashes with *.js group test files
SELECT QTLIST
SCAN
   Jname = ALLTRIM(QTLIST.name)
   * for each word gather all "on" test cases
   SELECT  JT.casecode, JT.testcase, ;
      JT.expecting, JT.assumes FROM JT ;
      WHERE ALLTRIM(JT.name) == Jname  AND !DELETED() AND JT.caseon ;
      INTO CURSOR QTESTS
   COUNT TO Ntests
   IF 0 < Ntests
      WAIT WINDOW 'Generating '+ALLTRIM(Jname)+' test cases' NOWAIT
      Dosfile = doslength(Jname)
      Tscript = JBtestdir+ALLTRIM(Dosfile)+".jt"
      IF FILE(Tscript)
         ERASE (Tscript)
      ENDIF
      * create file and set header
      Fout=FCREATE(Tscript)
      = FWRITE(Fout,'NB. '+ALLTRIM(Jname)+' word test case(s) generated on: ' ;
         + DTOC(DATE())+' '+TIME() )
      = FWRITE(Fout,JDnl+'NB. J test case(s) extracted from: '+ALLTRIM(JBdictid))
      = FWRITE(Fout,JDSpace)
      = FCLOSE(Fout)
      SELECT QTESTS
      SCAN
         * must open/close for COPY MEMO (Kludge!)
         Fout = FOPEN(Tscript,2)
         = FSEEK(Fout, 0, 2) && Move pointer to EOF
         = FWRITE(Fout,JDSpace)
         = FWRITE(Fout,'NB. BEGIN TEST: ' ;
            + ALLTRIM(QTESTS.testcase) + JDSpace)
         = FWRITE(Fout,'NB. ASSUMES: ' ;
            + ALLTRIM(QTESTS.assumes) + JDSpace)
         = FWRITE(Fout,'NB. EXPECTING: ' ;
            + ALLTRIM(QTESTS.expecting) + JDSpace)
         = FCLOSE(Fout)
         COPY MEMO QTESTS.casecode TO (Tscript) ADDITIVE
      ENDSCAN
      SELECT QTESTS
      USE
      Gcnt = Gcnt + 1 && count case
   ENDIF
ENDSCAN
SELECT QTLIST  && release group member cursor
USE
WAIT WINDOW ALLTRIM(STR(Gcnt))+' word test case script file(s) generated' NOWAIT
RETURN &&endproc:testwords


PROCEDURE usesbrow
* browse uses (concordance)
PRIVATE ALL EXCEPT JB*
DO clrrels WITH "bits"
SELECT JB
SET RELATION TO name INTO JUX
SET SKIP TO JUX
BROWSE NOWAIT PREFERENCE JBJUX
JBrelbits(JDJUXrels) = .T.
SELECT JUX
BROWSE NOWAIT PREFERENCE JUXJB
ACTIVATE WINDOW JB
SELECT JB
RETURN  &&endproc:usesbrow


FUNCTION calljword
* who uses a J word
PARAMETERS jname
PRIVATE ALL EXCEPT JB*
DIMENSION JBwork(1)
JBwork(1) = "*"  && Invalid group name
Jdata = ' '      && assume no calls
SELECT DISTINCT JUX.name FROM JUX INTO ARRAY JBwork ;
   WHERE ALLTRIM(JUX.uses) == jname AND !DELETED() && exact matches
IF JBwork(1) == "*"
   * word may not call anything or may not exist
   SELECT JB
   IF NOT SEEK(jname)
      Jdata = JBmissing
   ENDIF
ELSE
   Jdata = ""
   Jlen = ALEN(JBwork)
   FOR i = 1 TO Jlen
      Jdata = Jdata + ' ' + ALLTRIM(JBwork(i))
   ENDFOR
   DIMENSION JBwork(1)
ENDIF
RETURN Jdata &&endfunc:calljword


FUNCTION cleanstr
* replace all line end varients with a code
PARAMETERS dstr
PRIVATE ALL EXCEPT JB*
Clean = STRTRAN(dstr,JDcrlf,JDnl)
Clean = STRTRAN(Clean,JDcr,JDnl)
Clean = STRTRAN(Clean,JDnl,JDeol)
RETURN Clean &&endfunc:cleanstr


FUNCTION crjgrp
* create a group
PARAMETERS gname
PRIVATE ALL EXCEPT JB*
DO clrrels
Grpn = ALLTRIM(UPPER(gname))
Gnew = .T.
SELECT JG
IF SEEK(Grpn)
   IF ALLTRIM(UPPER(JG.jgroup)) == Grpn
      * group exists
      Gnew = .F.
      Jdata = JDGrphere
   ENDIF
ENDIF
IF Gnew
   * create group
   SELECT JG
   APPEND BLANK
   REPLACE jgroup WITH Grpn, generate WITH .F., ;
      teston WITH .F., readable WITH .F., locale WITH .F.
   Jdata = 'Group <'+Grpn+'> created'
ENDIF
DO setrels
RETURN Jdata &&endfunc:crjgrp


FUNCTION cutjcode
* parse J code strings into an array.
PARAMETERS jcode
PRIVATE ALL EXCEPT JB*
* this function is independent of FoxPro
* memo width settings and correctly splits strings
* based on line ends CHR(10), CHR(13) & CHR(13)+CHR(10)
Nlines = 0
IF 0 < LEN(jcode)
   Arsize = 20
   DIMENSION JBwork(Arsize)
   Code = cleanstr(jcode)               && standardize line ends
   Code = STRTRAN(Code,JDeol,' '+JDeol) && handle all blank lines
   Wcnt = 1
   Jline = nthitem(Code,Wcnt,JDeol)
   DO WHILE 0 < LEN(Jline) && empty test fails on blanks
      Nlines = Wcnt
      IF Arsize < Nlines   && J programs are << 64,000 lines
         Arsize = Arsize + 20
         DIMENSION JBwork(Arsize)
      ENDIF
      JBwork(Nlines) = Jline
      Wcnt = Wcnt + 1
      Jline = nthitem(Code,Wcnt,JDeol)
   ENDDO
   DIMENSION JBwork(Nlines)
ENDIF
RETURN Nlines &&endfunc:cutjcode


FUNCTION deljgrp
* delete a group
PARAMETERS gname
DO clrrels
Grpn = ALLTRIM(UPPER(gname))
SELECT JG
IF SEEK(Grpn)
   IF ALLTRIM(UPPER(JG.jgroup)) == Grpn
      * group exists delete it
      * DELETE FOR is overkill but handles non-unique groups
      SET EXACT ON
      DELETE FOR jgroup = Grpn
      DO empjgroup WITH Grpn
      SET EXACT OFF
      Jdata = 'Group <'+Grpn+'> deleted'
   ELSE
      Jdata = JDGrpambig
   ENDIF
ELSE
   Jdata = JDGrpgone
ENDIF
DO setrels
RETURN Jdata &&endfunc:deljgrp


FUNCTION deljword
* delete one J word from dictionary.
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "DEL,NAME,MASK"
DO clrrels && clear relations
SET EXACT ON
SELECT JB
COUNT FOR name = jname TO Jdelcnt
DO CASE
CASE 0 = Jdelcnt  && nothing to change (assume integrity!)
   Jdata = JBmissing
CASE 1 < Jdelcnt  && database corrupt
   Jdata = JDIntegbad + Jname
CASE 1 = Jdelcnt
   SELECT JUX
   * is word used by other words?
   COUNT FOR uses = jname TO Jdelcnt
   IF 0 < Jdelcnt
      Jdata = JDInuse + ' (words)'
   ELSE
      * is word used by any test cases?
      SELECT JT
      COUNT FOR name = jname TO Jdelcnt
      IF 0 < Jdelcnt
         Jdata = JDInuse + ' (test cases)'
      ELSE
         * is word in any groups?
         SELECT JGX
         COUNT FOR name = jname TO Jdelcnt
         IF 0 < Jdelcnt
            Jdata = JDInuse + ' (groups)'
         ELSE
            * delete word
            SELECT JB
            DELETE FOR name = jname
            SELECT JUX
            DELETE FOR name = jname
            Jdata = "<" + jname + "> deleted from " + JBdictid
         ENDIF
      ENDIF
   ENDIF
ENDCASE
SELECT JB
SET EXACT OFF
DO setrels && resore relations
RETURN Jdata &&endfunc:deljword


FUNCTION dictbrow
* set dictionary browse windows
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "BRW,type" type is one of "wrd" "grp" "uses" "test"
DO CASE
CASE jname = 'wrd'
   DO hidewins
   DO jbbrow
   Jdata = 'Browsing words'
CASE jname = 'grp'
   DO hidewins
   DO grpbrow
   Jdata = 'Browsing groups'
CASE jname = 'uses'
   DO hidewins
   DO usesbrow
   Jdata = 'Browsing uses or concordance'
CASE jname = 'test'
   DO hidewins
   DO testbrow
   Jdata = 'Browsing test cases'
OTHERWISE
   Jdata = JDBadbr
ENDCASE
RETURN Jdata &&endfunc:dictbrow


FUNCTION doslength
* truncate string to DOS file name length
PARAMETERS fname
Trname = ALLTRIM(fname)
RETURN IIF(8 < LEN(Trname), SUBSTR(Trname,1,8), Trname)  &&endfunc:doslength


FUNCTION empjgrp
* empty a group
PARAMETERS gname
PRIVATE ALL EXCEPT JB*
DO clrrels
Jdata = JDGrpgone  && assume group gone
Grpn = ALLTRIM(UPPER(gname))
SELECT JG
IF SEEK(Grpn)
   IF ALLTRIM(UPPER(JG.jgroup)) == Grpn
      * group exists
      Ggone = .F.
      DO empjgroup WITH Grpn
      Jdata = 'Group <'+Grpn+'> emptied'
   ENDIF
ENDIF
DO setrels
RETURN Jdata &&endfunc:empjgrp


FUNCTION fldget
* return any single JB field value
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
SELECT JB
* <item> syntax is "FLD,NAME,MASK,FIELD"
IF EMPTY(jname) && return list of fields
   Jdata = ""
   FOR Fcnt = 1 TO JBfcnt
      Jdata = Jdata + " " + ALLTRIM(JBflds(Fcnt))
   ENDFOR
ELSE
   IF SEEK(jname)
      Jfield = UPPER(nthitem(item,4))
      Jok = .F.
      FOR Fcnt = 1 TO JBfcnt
         IF Jfield = JBflds(Fcnt)
            Jok = .T.
            EXIT
         ENDIF
      ENDFOR
      IF Jok
         Jdata = JBflds(Fcnt)
         Jdata = &Jdata
         Jdata = jddefld(Jdata)
      ELSE
         Jdata = JDBadfld
      ENDIF
   ELSE
      Jdata = JBmissing
   ENDIF
ENDIF
RETURN Jdata &&endfunc:fldget


FUNCTION forinteg
* test foreign key integrity
PARAMETERS fout, tfile, xalias, xkey, yalias, ykey
PRIVATE ALL EXCEPT JB*
Result = .F.  && assume the worst
* All foreign keys in an "X" table must exist as
* primary keys in a related "Y" table. The following
* SELECT is empty for correct key relations.
Fxkey = UPPER(ALLTRIM(xkey))
Ftfile = UPPER(ALLTRIM(tfile))
Kmsg = 'Testing foreign key ' + Fxkey + ' in ' + Ftfile
WAIT WINDOW Kmsg NOWAIT
SELECT &xkey FROM &xalias ;
   WHERE &xkey NOT IN (SELECT &ykey FROM &yalias WHERE !DELETED()) ;
   AND !DELETED() INTO CURSOR QTEMP
COUNT TO Violations
IF 0 < Violations
   Kmsg = "Invalid fkeys " + Fxkey +  " in " + Ftfile ;
      + " (primary alias -> " + UPPER(yalias) + ")"
   WAIT WINDOW Kmsg NOWAIT
   ? Kmsg
   = FWRITE(fout, JDSpace + Kmsg + JDnl)
   SELECT QTEMP
   SCAN
      Kval = &xkey  && xkey is an unqualified (no ".") field name
      Kmsg = "Key: " + kval
      ? Kmsg
      = FPUTS(fout, Kmsg)
   ENDSCAN
   Result = .F.
ELSE
   WAIT WINDOW 'fkey ' + Fxkey + ' ok in ' + Ftfile NOWAIT
   Result = .T.
ENDIF
SELECT QTEMP && release cursor
USE
RETURN Result &&endfunc:forinteg


FUNCTION groups
* list groups and their contents
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "GRP,GROUP,MASK"
DIMENSION JBwork(1)
JBwork(1) = "*"   && Invalid group name
Jgrname = UPPER(jname)
Jdata = ""
IF EMPTY(jname)
   * return a list of all groups
   SELECT JG.jgroup FROM JG INTO ARRAY JBwork ;
      WHERE !DELETED() ORDER BY 1
ELSE
   * return the members of one group
   SELECT JGX.name FROM JGX INTO ARRAY JBwork ;
      WHERE ALLTRIM(JGX.jgroup) == Jgrname AND !DELETED();
      ORDER BY 1
ENDIF
IF JBwork(1) == "*"
   * determine if group is empty
   Jdata = JDGrpgone
   IF NOT EMPTY(Jgrname)
      SELECT JG
      IF SEEK(Jgrname)
         IF Jgrname == ALLTRIM(UPPER(JG.jgroup))
            Jdata = ' ' && J cuts to null
         ENDIF
      ENDIF
   ENDIF
ELSE
   Jlen = ALEN(JBwork)
   FOR i = 1 TO Jlen
      Jdata = Jdata+' '+ALLTRIM(JBwork(i))
   ENDFOR
   DIMENSION JBwork(1)
ENDIF
RETURN Jdata &&endfunc:groups


FUNCTION grpjmake
* fill a dictionary group
PARAMETER grname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "GMK,GRNAME,MASK,swapfile"
Gname = UPPER(grname)
Jdata = JDGrpgone
SELECT JG
IF SEEK(Gname)
   IF Gname == UPPER(ALLTRIM(jgroup))
      * group exists test names for dictionary membership
      Jdata = jmissing(item)
      IF 0 = LEN(Jdata)
         * nothing missing update group
         DO empjgroup WITH Gname
         * jdtemp.dbf created by jmissing has a "name" field
         SELECT JGX
         APPEND FROM jdtemp
         REPLACE jgroup WITH Gname, interface WITH .F. FOR EMPTY(jgroup)
         Jdata = 'Group <' + Gname + '> updated'
      ELSE
         Jdata = JDSerpfx + "missing->" + Jdata
      ENDIF
   ENDIF
ENDIF
RETURN Jdata &&endfunc:grpjmake


FUNCTION herejfiles
* test existence of database files
PARAMETERS dummy
PRIVATE ALL EXCEPT JB*
Jok = .T.  && assume files exist
* test main tables and memo files
Jok = Jok AND FILE(ALLTRIM(JBcode)+'.dbf')
Jok = Jok AND FILE(ALLTRIM(JBcode)+'.fpt')
Jok = Jok AND FILE(ALLTRIM(JBgroups)+'.dbf')
Jok = Jok AND FILE(ALLTRIM(JBgroups)+'.fpt')
Jok = Jok AND FILE(ALLTRIM(JBgrlist)+'.dbf')
Jok = Jok AND FILE(ALLTRIM(JBuses)+'.dbf')
Jok = Jok AND FILE(ALLTRIM(JBtests)+'.dbf')
Jok = Jok AND FILE(ALLTRIM(JBtests)+'.fpt')
* if no args test index files
IF 0 = PARAMETERS()
   Jok = Jok AND FILE(ALLTRIM(JBcode)+'.cdx')
   Jok = Jok AND FILE(ALLTRIM(JBgroups)+'.cdx')
   Jok = Jok AND FILE(ALLTRIM(JBgrlist)+'.cdx')
   Jok = Jok AND FILE(ALLTRIM(JBuses)+'.cdx')
   Jok = Jok AND FILE(ALLTRIM(JBtests)+'.cdx')
ENDIF
RETURN Jok  &&endfunc:herejfiles


FUNCTION injgrps
* all groups a word belongs to
PARAMETERS jname
PRIVATE ALL EXCEPT JB*
DIMENSION JBwork(1)
JBwork(1) = "*"  && Invalid group name
Jdata = ' '      && assume word is not in any group
SELECT DISTINCT JGX.jgroup FROM JGX INTO ARRAY JBwork ;
   WHERE ALLTRIM(JGX.name) == jname AND !DELETED() && exact matches
IF JBwork(1) == "*"
   * word may not belong to a group or may not exist
   SELECT JB
   IF NOT SEEK(jname)
      Jdata = JBmissing
   ENDIF
ELSE
   Jdata = ""
   Jlen = ALEN(JBwork)
   FOR i = 1 TO Jlen
      Jdata = Jdata + ' ' + ALLTRIM(JBwork(i))
   ENDFOR
   DIMENSION JBwork(1)
ENDIF
RETURN Jdata &&endfunc:injgrps


FUNCTION jconfig
PRIVATE ALL EXCEPT JB*
Setok = .F.  && assume the worst
IF FILE('JDICTCFG.DBF')
   USE JDICTCFG IN 0 ALIAS JD
   * the first record is used the second
   * contains examples of valid settings
   GO TOP
   * file structure not tested
   JBcode   = ALLTRIM(JD_CODE)     && Name of main code table
   JBgroups = ALLTRIM(JD_GROUPS)   && Name of main groups table
   JBgrlist = ALLTRIM(JD_GRLIST)   && Name of name-group xref table
   JBuses   = ALLTRIM(JD_USES)     && Name of name-uses xref table
   JBtests  = ALLTRIM(JD_TESTS)    && Name of test case table
   JBjsdir  = ALLTRIM(JD_DIR)      && Main dictionary data directory
   JBgrdir  = ALLTRIM(JD_GRDIR)    && Directory where J group scripts are written
   JBtestdir = ALLTRIM(JD_JTDIR)   && Directory where J test cases are written
   JBdictid = ALLTRIM(JD_DICTID)   && Name of dictionary
   JBjver   = ALLTRIM(JD_JVER)     && Current version of J
   JBdumpjs  = ALLTRIM(JD_DUMPJS)  && Name of dictionary J dump script
   JBdumpdmp = ALLTRIM(JD_DUMPDMP) && (unused)
   JBdumpdir = ALLTRIM(JD_DUMPDIR) && Dump directory
   SELECT JD
   USE
   Setok = .T.
ENDIF
RETURN Setok &&endfunc:jconfig


FUNCTION jddefld
* formats a single field for DDE transfer
PARAMETERS jdata
PRIVATE ALL EXCEPT JB*
Jtype = TYPE('jdata')
DO CASE  && first character indicates datatype
CASE 'C' = Jtype
   Result = 'C'+jdata
CASE 'N' = Jtype
   Result = 'N'+STR(jdata)
CASE 'L' = Jtype
   Result = 'L'+IIF(jdata,'1','0')
CASE 'D' = Jtype
   Result = 'D'+DTOS(jdata) && YYYYMMDD format
CASE 'M' = Jtype
   Result = 'M'+jdata
OTHERWISE
   Result = JDBadtype
ENDCASE
RETURN Result &&endfunc:jddefld


FUNCTION jddefmt2
* formats J code for DDE transfer
PARAMETERS name, script, tacit
PRIVATE ALL EXCEPT JB*
Tac = ALLTRIM(STR(tacit))
Result = Tac + ALLTRIM(name) + "=: " + script
RETURN Result &&endfunc:jddefmt2


FUNCTION jlatexit
* replace special LaTeX chars with codes
PARAMETERS tline
PRIVATE ALL EXCEPT JB*
Latex = ' ' + tline + ' '
Latex = STRTRAN(Latex,'$','\$')
Latex = STRTRAN(Latex,'&','\&')
Latex = STRTRAN(Latex,'%','\%')
Latex = STRTRAN(Latex,'#','\#')
Latex = STRTRAN(Latex,'_','\_')
Latex = STRTRAN(Latex,'{','\{')
Latex = STRTRAN(Latex,'}','\}')
* bold face J's x. and y.
Latex = STRTRAN(Latex,' x. ',' {\bf x.\ } ')
Latex = STRTRAN(Latex,' y. ',' {\bf y.\ } ')
Latex = ALLTRIM(Latex)
RETURN Latex &&endfunc:jlatexit


FUNCTION jmissing
* list of swap file names not in dictionary
PARAMETERS item
* <item> syntax is "?,?,?,swapfile" where "swapfile" is a fullpath filename
PRIVATE ALL EXCEPT JB*
Swap = nthitem(item,4)
IF FILE(Swap)
   DIMENSION JBwork(1)
   JBwork(1) = "*"  && invalid name
   IF FILE('jdtemp.dbf')
      ERASE jdtemp.dbf
   ENDIF
   CREATE TABLE jdtemp (name C(JDNamewid))
   APPEND FROM (Swap) DELIMITED
   * select missing names
   SELECT DISTINCT * FROM jdtemp INTO ARRAY JBwork ;
      WHERE name NOT IN (SELECT name FROM JB WHERE !DELETED()) ;
      ORDER BY 1
   SELECT jdtemp
   USE
   IF JBwork(1) == "*"
      Jdata = ""
   ELSE
      Jdata = ""
      Jlen = ALEN(JBwork)
      FOR i = 1 TO Jlen
         Jdata = Jdata+' '+ALLTRIM(JBwork(i))
      ENDFOR
      DIMENSION JBwork(1)
   ENDIF
   SELECT JB && leave a table in use
ELSE
   Jdata = JDNoswap
ENDIF
RETURN Jdata &&endfunc:jmissing


FUNCTION latexcode
* convert J code to a LaTeX'able format
PARAMETERS varn, tadef, scrcode, expln, nclss
PRIVATE ALL EXCEPT JB*
Jcode = ""
Jok = .T.  && optimism
DO CASE
CASE nclass = 2
   Jcat = "Noun"
CASE nclass = 3
   Jcat = "Verb"
CASE nclass = 4
   Jcat = "Adverb"
CASE nclass = 5
   Jcat = "Conjunction"
OTHERWISE
   Jok = .F.  && bad name class
ENDCASE
Vn = ALLTRIM(varn)
IF Jok
   Vntag = Vn + '+' + UPPER(Jcat)
   Jcode = Jcode + '\noindent {\tt\normalsize\bf ' + Vn + ;
      '\index{' + Vntag + '}\label{' ;
      + Vntag + '}} {\normalsize\it ' + ;
      LOWER(Jcat) + '\/} {\rm\normalsize ' ;
      + ALLTRIM(jlatexit(expln)) + '}' + JDSpace
   IF tadef = 1
      Jcode = Jcode + JDVskip + JDSpace
      Jcode = Jcode + texverb(Vn+' =: '+ALLTRIM(scrcode)) + JDSpace && tacit
      Jcode = Jcode + JDVskip + JDSpace
   ELSE
      IF NOT EMPTY(scrcode)
         Nlines = cutjcode(scrcode) && load array JBwork()
         IF 0 < Nlines
            Jcode = Jcode + JDVskip + JDSpace
            Hskip = .T.
            Lout  = .F.
            FOR i = 1 TO Nlines
               * skip any leading blank lines
               IF Hskip
                  IF 0 = LEN(ALLTRIM(Jbwork(i)))
                     LOOP
                  ELSE
                     * have found header line - skip it
                     Hskip = .F.
                     IF Nlines < i + 1
                        i = i + 1
                     ENDIF
                     LOOP
                  ENDIF
               ENDIF
               Jline = ALLTRIM(JBwork(i))
               DO CASE
               CASE Jline == ')'  && end of J definition
                  IF NOT Lout
                     Jcode = Jcode + JBnullcode
                  ENDIF
                  Jcode = Jcode + JDVskip
                  EXIT
               CASE Jline == ':'  && monad/dyad delimiter
                  IF NOT Lout
                     Jcode = Jcode + JBnullcode
                  ENDIF
                  Jcode = Jcode + JDUpdownar + JDSpace
                  Lout = .F.
               OTHERWISE
                  * re-extract line to preserve J indentation
                  Lout = .T.
                  Jcode = Jcode + texverb(JBwork(i)) + JDSpace
               ENDCASE
            ENDFOR
         ENDIF
      ENDIF
   ENDIF
ENDIF
RETURN Jcode &&endfunc:latexcode


FUNCTION notput
* return list of J workspace names not saved in dictionary
PARAMETERS item
* <item> syntax is "NP,,0,swapfile" where "swapfile" is a fullpath filename
Jdata = jmissing(item)
Jdata = IIF(0 = LEN(Jdata), '*All words in ' + JBdictid, Jdata)
RETURN Jdata &&endfunc:notput


FUNCTION nthitem
PARAMETERS item, pos, sep
**== ----------------------------------------------------------------- **
* Nth substring from "str1[del]str2[del]str3 ... [del]strn" lists
*| Calling sequences:
*|     nthitem("go,ahead,cut,me",2)
*|     nthitem("yea**like**I**care",3,"**")
** ----------------------------------------------------------------- ==**
PRIVATE Finish, Start, Result, Del, Dlen
Del = IIF(2=PARAMETERS(),',',sep) && set delimiter ',' is default
Dlen = LEN(Del)
item = Del+item+Del
Start = AT(Del,item,pos)
Finish = AT(Del,item,pos+1)
IF Start = 0 OR Finish = 0
   Result = ""
ELSE
   Result = SUBSTR(item,Start+Dlen,(Finish-Start-Dlen))
ENDIF
RETURN Result &&endfunc:nthitem


FUNCTION openjdict
* open database files
PRIVATE ALL EXCEPT JB*
JBerror = .F.
* set error trap to catch all manner of open file
* errors.  The database typically fails to open
* because of index damage, to many files open,
* files already open, and so forth.  My approach
* is to inform the user and then stop the
* dictionary database startup process.
ON ERROR DO openjerror WITH MESSAGE(1)
USE (JBcode) IN 0 ORDER name ALIAS JB EXCLUSIVE
USE (JBgroups) IN 0 ORDER jgroup ALIAS JG EXCLUSIVE
USE (JBgrlist) IN 0 ORDER jview ALIAS JGX EXCLUSIVE
USE (JBuses) IN 0 ORDER name ALIAS JUX EXCLUSIVE
USE (JBtests) IN 0 ORDER name ALIAS JT EXCLUSIVE
ON ERROR
IF JBerror
   CLOSE DATABASES
ENDIF
Result = NOT JBerror
* reset main error trap
ON ERROR DO jdcrash WITH ;
   ERROR( ), MESSAGE( ), MESSAGE(1), PROGRAM( ), LINENO( )
RETURN Result &&endfunc:openjdict


FUNCTION pkeytest
* is the primary key unique?
PARAMETERS aname, pkey
PRIVATE ALL EXCEPT JB*
Result = .T.
SELECT (aname)
COUNT TO Pkeycnt
SELECT DISTINCT &pkey FROM &aname INTO CURSOR QTEMP
COUNT TO Qkeycnt
SELECT QTEMP
USE
IF Pkeycnt != Qkeycnt
   Result = .F.
ENDIF
RETURN Result &&endfunc:pkeytest


FUNCTION put2jcode
* put a J word into the dictionary
PARAMETERS jname, item, DATA
PRIVATE ALL EXCEPT JB*
SELECT JB
* Code update <item> is "P2,NAME,MASK,NCLASS,TACIT"
Jok = .F.   && assume partial match
Jclass = VAL(nthitem(item,4))
Jtacit = VAL(nthitem(item,5))
Jmatch = ALLTRIM(jname)
Newj = .T.
IF SEEK(Jmatch)
   * name exists test for exact match
   IF Jmatch == ALLTRIM(name)
      Newj = .F.
      Jok = .T.
      REPLACE changed WITH DATE(), changecnt WITH changecnt + 1, ;
         jversion WITH JBjver, changesec WITH SECONDS() ;
         tacit WITH Jtacit, nclass WITH Jclass
   ENDIF
ENDIF
IF Newj
   * new name
   Jok = .T.
   Jsecs = SECONDS() && insure create and change identical
   APPEND BLANK
   REPLACE name WITH Jmatch,  creation WITH DATE(), ;
      changed WITH DATE(), changecnt WITH 0, jversion WITH JBjver ;
      changesec WITH Jsecs, creatsec WITH Jsecs ;
      tacit WITH Jtacit, nclass WITH Jclass
ENDIF
IF Jok
   * restore quotes and semicolons and store code
   Jdata = STRTRAN(DATA,JDQuoterep,'"')
   Jdata = STRTRAN(Jdata,JDSemirep,';')
   REPLACE lastscript WITH script, script WITH Jdata
ENDIF
RETURN Jok &&endfunc:put2jcode


FUNCTION readtxt
* Read entire text file as a character string
PARAMETERS fname
PRIVATE ALL
* set error trap to catch file to big
* errors -- what you can read in depends
* on what's in memory it's easiar to attempt
* a read and fail that determine if you can read
Result = -1
f_hand = FOPEN(ALLTRIM(fname))  && open file
IF f_hand != -1
   f_size = FSEEK(f_hand, 0, 2) && Move pointer to EOF
   f_top = FSEEK(f_hand, 0)		&& Move pointer to BOF
   IF f_size > 0
      ON ERROR DO nop
      Result = FREAD(f_hand, f_size)
      * reset main error trap
      ON ERROR DO jdcrash WITH ;
         ERROR( ), MESSAGE( ), MESSAGE(1), PROGRAM( ), LINENO( )
   ENDIF
ENDIF
= FCLOSE(f_hand)
RETURN Result &&endfunc:readtxt


FUNCTION recase
* restore letter case from mask
PARAMETERS togstr, mask
PRIVATE ALL
IF LEN(togstr) != LEN(mask)
   Result = -1   && length error
ELSE
   Result = ""
   Slen = LEN(togstr)
   FOR i = 1 TO Slen
      cc = SUBSTR(togstr,i,1)
      mm = SUBSTR(mask,i,1)
      Result = Result + IIF(ISALPHA(cc) AND ('0'=mm),LOWER(cc),cc)
   ENDFOR
ENDIF
RETURN Result  &&endfunc:recase


FUNCTION renjword
* rename one J word in dictionary
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "REN,NAME,NAMEMASK,NEWNAME,NEWMASK"
DO clrrels  && clear relations
* The new name is never empty - J rnto word insures this.
Jnewname = ALLTRIM(recase(nthitem(item,4), nthitem(item,5)))
SET EXACT ON
SELECT JB
COUNT FOR name = jname TO Jrencnt
COUNT FOR name = Jnewname TO Jnewcnt
DO CASE
CASE 0 = Jrencnt  && nothing to change (assume integrity!)
   Jdata = JBmissing
CASE 1 = Jnewcnt
   Jdata = JDSerpfx + ' <' + Jnewname + '> already in ' + JBdictid
CASE 1 < Jrencnt  && database corrupt
   Jdata = JDIntegbad + Jname
CASE 1 < Jnewcnt  && database corrupt
   Jdata = JDIntegbad + Jnewname
CASE 1 = Jrencnt
   * is word used by other words?
   SELECT JUX
   COUNT FOR uses = jname TO Jrencnt
   IF 0 < Jrencnt
      Jdata = JDInuse + ' (words)'
   ELSE
      * is word used by any test cases?
      SELECT JT
      COUNT FOR name = jname TO Jrencnt
      IF 0 < Jrencnt
         Jdata = JDInuse + ' (test cases)'
      ELSE
         * is word in any groups?
         SELECT JGX
         COUNT FOR name = jname TO Jrencnt
         IF 0 < Jrencnt
            Jdata = JDInuse + ' (groups)'
         ELSE
            * rename word
            SELECT JB
            REPLACE name WITH Jnewname FOR name = jname
            SELECT JUX
            REPLACE name WITH Jnewname FOR name = jname
            Jdata = "<" + Jname + "> renamed to <" + Jnewname ;
               + "> in " + JBdictid
         ENDIF
      ENDIF
   ENDIF
ENDCASE
SELECT JB
SET EXACT OFF
DO setrels  && restore relations
RETURN Jdata &&endfunc:renjword


FUNCTION scriptcode2
* convert J code to script format
PARAMETERS varn, scrn
PRIVATE ALL EXCEPT JB*
* standardize line ends
Code = STRTRAN(scrn,JDcrlf,JDnl)
Code = STRTRAN(Code,JDcr,JDnl)
Code = ALLTRIM(varn) + " =: " + Code
RETURN Code &&endfunc:scriptcode2


FUNCTION seekjwords
* search dictionary for J words
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "SEEK,NAME,MASK,ALL" last "ALL" may be "ONE"
SELECT JB
IF 'ONE' = UPPER(nthitem(item,4))
   * return first match
   IF SEEK(jname)
      Jdata = " "+ALLTRIM(name) && leading blank for J cut
   ELSE
      Jdata = JBmissing
   ENDIF
ELSE
   * return all matches
   DIMENSION JBwork(1)
   JBwork(1) = "*"   && Invalid J name
   Jdata = ""
   SELECT JB.name FROM JB INTO ARRAY JBwork ;
      WHERE JB.name = jname AND !DELETED() ORDER BY 1
   IF JBwork(1) == "*"
      Jdata = JBmissing
   ELSE
      Jlen = ALEN(JBwork)
      FOR i = 1 TO Jlen
         Jdata = Jdata+' '+ALLTRIM(JBwork(i))
      ENDFOR
      DIMENSION JBwork(1)
   ENDIF
ENDIF
RETURN Jdata &&endfunc:seekjwords


FUNCTION texverb
* format a single J code line for the LaTeX \verb command
PARAMETERS jline
PRIVATE ALL EXCEPT JB*
Tlen = LEN(JBtexdels)
Ok = .F.
FOR i = 1 TO Tlen
   Del = SUBSTR(JBtexdels,i,1)
   IF 0 = AT(Del,jline) && delimiter cannot be in line
      Ok = .T.
      EXIT
   ENDIF
ENDFOR
IF Ok
   Lverb = '\verb' + Del + ' ' + jline + ' ' + Del
ELSE
   Lverb = '\verb| <<cannot print line>> |'
ENDIF
RETURN Lverb &&endfunc:texverb


FUNCTION useall
PARAMETERS jname
**== ----------------------------------------------------------------- **
* This algorithm gathers ALL the words used by a given word.
* Usually algorithms of this type are recursive. The FoxPro
* language does not support serious recursive programming.  To
* avoid recursion this algorithm iteratively SQL selects unsearched
* words from a list, marking selected words searched, until no
* more unsearched words remain.
*| Calling sequence:
*|     useall('searchme')
** ----------------------------------------------------------------- ==**
PRIVATE ALL EXCEPT JB*
SELECT JB
Jdata = JBmissing && assume missing
IF SEEK(jname)
   IF ALLTRIM(name) == jname
      * references bottom out at nouns.  If a noun
      * refrences a word via execute or gerunds it
      * is missed by this static name analysis algorithm.
      Jdata = ' '
      IF JB.nclass != 2
         IF FILE('jdtemp.dbf')
            ERASE jdtemp.dbf
         ENDIF
         CREATE TABLE jdtemp (name C(JDNamewid), nclass N(1), searched L)
         USE
         USE jdtemp IN 0 ALIAS JW
         DIMENSION JBwork(1)
         DIMENSION Juses(1,1)
         Juses(1,1) = "*"
         SET EXACT ON
         JBwork(1) = jname && handle recursive and dyad calls
         unsearched = .T.
         DO WHILE unsearched
            IF JBwork(1) == "*"
               unsearched = .F.
            ELSE
               Jlen = ALEN(JBwork)
               FOR i = 1 TO Jlen
                  Sname = ALLTRIM(JBwork(i))
                  SELECT JUX.uses, JB.nclass, .F. FROM JUX, JB ;
                     INTO ARRAY Juses WHERE ;
                     JUX.uses NOT IN (SELECT JW.name FROM JW) ;
                     AND Sname == JUX.name AND JUX.uses = JB.name ;
                     AND !DELETED()
                  IF NOT Juses(1,1) == "*"
                     SELECT JW
                     APPEND FROM ARRAY Juses
                     DIMENSION Juses(1,1)
                     Juses(1,1) = "*"
                  ENDIF
                  REPLACE searched WITH .T. FOR name = Sname
               ENDFOR
               DIMENSION JBwork(1)
               JBwork(1) = "*"
            ENDIF
            SELECT DISTINCT name FROM JW INTO ARRAY JBwork ;
               WHERE (NOT searched) AND nclass != 2
         ENDDO
         SELECT DISTINCT name FROM JW INTO ARRAY JBwork ORDER BY 1
         IF NOT JBwork(1) == "*"
            Jdata = ""
            Jlen = ALEN(JBwork)
            FOR i = 1 TO Jlen
               Jdata = Jdata + ' ' + ALLTRIM(JBwork(i))
            ENDFOR
            DIMENSION JBwork(1)
         ENDIF
         SET EXACT OFF
         SELECT JW
         USE
         SELECT JB && leave a table in use
      ENDIF
   ENDIF
ENDIF
RETURN Jdata &&endfunc:useall


FUNCTION uselist
* list of J objects used by jname
PARAMETERS jname
PRIVATE ALL EXCEPT JB*
IF EMPTY(ALLTRIM(jname))  && don't look for empties
   Jdata = ""
ELSE
   SELECT JB && insure a table in use
   DO clrrels
   DIMENSION JBwork(1)
   JBwork(1) = "*"  && Invalid  name
   Jdata = ""
   SELECT DISTINCT JUX.uses FROM JUX INTO ARRAY JBwork ;
      WHERE JUX.name == jname AND !DELETED() && exact matches
   IF JBwork(1) == "*"
      * There are two possibilities - the
      * select failed because the sought object
      * does not "use" anything or the name sought
      * is not in JB. The first condition is fine
      * the second is an error.
      SELECT JB
      Jdata = IIF(SEEK(jname), "", JBmissing)
   ELSE
      Jlen = ALEN(JBwork)
      FOR i = 1 TO Jlen
         Jdata = Jdata+' '+ALLTRIM(JBwork(i))
      ENDFOR
      DIMENSION JBwork(1)
   ENDIF
   DO setrels
ENDIF
RETURN Jdata &&endfunc:uselist


FUNCTION usesjup
* update uses or concordance table
PARAMETERS jname, item
PRIVATE ALL EXCEPT JB*
* <item> syntax is "CON,NAME,MASK,swap" where swap is a fullpath file name
Swap = nthitem(item,4)
IF FILE(Swap)
   DIMENSION JBwork(1)
   JBwork(1) = "*"  && invalid name
   IF FILE('jdtemp.dbf')
      ERASE jdtemp.dbf
   ENDIF
   * used names jdtemp is never empty the J word "uses" insures this
   CREATE TABLE jdtemp (name C(JDNamewid))
   APPEND FROM (Swap) DELIMITED
   * select missing names
   SELECT DISTINCT * FROM jdtemp INTO ARRAY JBwork ;
      WHERE name NOT IN (SELECT name FROM JB WHERE !DELETED()) ORDER BY 1
   IF JBwork(1) == "*"
      * all used words exist in dictionary add to uses table
      SELECT * FROM jdtemp INTO ARRAY JBwork
      SET EXACT ON
      SELECT JUX
      SET ORDER TO name
      * remove previous references for this name
      DELETE FOR name = jname
      SET EXACT OFF
      Jlen = ALEN(JBwork)
      * add new used names to table
      FOR i = 1 TO Jlen
         APPEND BLANK
         REPLACE name WITH jname, uses WITH JBwork(i)
      ENDFOR
      Jdata = JBdictid + " concordance updated"
   ELSE
      * names are missing do not update concordance
      * report missing to J
      Jdata = ""
      Jlen = ALEN(JBwork)
      FOR i = 1 TO Jlen
         Jdata = Jdata+' '+ALLTRIM(JBwork(i))
      ENDFOR
      DIMENSION JBwork(1)
      Jdata = JDSerpfx + "missing->" + Jdata
   ENDIF
   SELECT jdtemp
   USE
   SELECT JB && leave a table in use
ELSE
   Jdata = JDNoswap
ENDIF
RETURN Jdata &&endfunc:usesjup


FUNCTION writetxt
* write entire string to file
PARAMETERS strdata, fname
PRIVATE ALL
Oname = ALLTRIM(fname)
Result = -1     && assume failure
IF NOT FILE(OName)
   f_hand = FCREATE(OName)  && create file
   IF f_hand != -1
      Result = FWRITE(f_hand,strdata)
   ENDIF
   = FCLOSE(f_hand)
ENDIF
RETURN Result &&endfunc:writetxt
